#include "Array.au3"

; Scurit pour pouvoir refermer une fentre bugue.
HotKeySet("{ESC}", "xxxFnBFermer")
Func xxxFnBFermer()
	Exit
EndFunc ; ==> FnBFermer
ControlSend("[CLASS:SciTEWindow]", "", "Scintilla2", "+{F5}")

Main()

; ==== Programme principal ========================================================================
Func Main()
	Local $aX[1]
	$aX[0] = "Item 0"

	BarreAttente_Traitements("INIT")
	For $i = 1 to 100
		Sleep(30)
		If Not BarreAttente_Traitements("MAJ") Then ExitLoop
	Next
	BarreAttente_Traitements("FIN")

	_ArrayDisplay($aX)
	If MsgBox(1+48+8192, "Stop", "- Fin traitement -") = 2 Then Exit
EndFunc
; =================================================================================================


; ==== Usage utilisateur ==========================================================================
; Sujet : Gestion d'une barre de progression
; Param : $sCas = Cas de gestion : "INIT", "MAJ" ou "FIN"
; Retour: True/False (False uniquement si clic sur bouton "Annuler").
; =================================================================================================
Func BarreAttente_Traitements($sCas)
	Static Local $hGUI        = 0 ; CtrlId de la GUI barre d'attente.
	Static Local $iTexte1_Id  = 0 ; CtrlId de la 1re zone de texte.
	Static Local $iProgre_Id  = 0 ; CtrlId de la barre de progression.
	Static Local $iTexte2_Id  = 0 ; CtrlId de la 2me zone de texte.
	Static Local $iFaits      = 0 ; Nb d'lments dj faits (pour barre progressive).
	Static Local $iTotal      = 100 ; Nb d'lments  faire au total (pour barre progressive).
	Static Local $bAnnulation = False ; Tmoin d'une annulation en cours.

	Switch $sCas
		Case "INIT"
			Local $iAnnuler_Id
			$hGUI        = GUICreate("Titre fentre", 320, 120, -1, -1)
			$iTexte1_Id  = GUICtrlCreateLabel("Texte", 20, 10, 280, 20)
			$iProgre_Id  = GUICtrlCreateProgress(20, 28, 280, 20)
			$iTexte2_Id  = GUICtrlCreateLabel("", 20, 53, 280, 20)
			$iAnnuler_Id = GUICtrlCreateButton("Annuler", 125, 70, 70, 20)
			; Enregistrement de la fonction de gestion des messages Windows.
			; (utilise uniquement pour le bouton "Annuler"). [0x0111 = $WM_COMMAND]
			GUIRegisterMsg(0x0111, "BarreAttente_WM_COMMAND")
			; Mmorisation en commarea de l'identifiant du bouton.
			BarreAttente_Commarea("$iAnnuler_Id", $iAnnuler_Id)
			GUISetState()
			ConsoleWrite("- BarreAttente_Traitements -" & @CRLF _
									& "$hGUI        = " & $hGUI & @CRLF _
									& "$iTexte1_Id  = " & $iTexte1_Id & @CRLF _
									& "$iProgre_Id  = " & $iProgre_Id & @CRLF _
									& "$iTexte2_Id  = " & $iTexte2_Id & @CRLF _
									& "$iAnnuler_Id = " & $iAnnuler_Id & @CRLF _
									& "----------------------------" & @CRLF)

		Case "MAJ"
			Local $iPourcentage
			; Appel sans tre pass d'abord par le cas "INIT".
			If Not $hGUI Then Return True
			; Interruption du traitement par une annulation.
			If $bAnnulation Then
				$bAnnulation = False
				Return False
			EndIf
			; Calcul des lments faits et du total d'lments  faire.
			$iFaits = $iFaits + 1
			$iPourcentage = Ceiling(($iFaits/$iTotal)*100)
			; Affichage du texte de la progression.
			GUICtrlSetData($iTexte2_Id, $iPourcentage & "%")
			; Affichage de la barre de progression actualise.
			GUICtrlSetData($iProgre_Id, $iPourcentage)
			Return True

		Case "FIN"
			; Ce cas est appel sans tre pass d'abord par le cas "INIT".
			If Not $hGUI Then Return
			; Fermeture de la fentre.
			GUIDelete($hGUI)
			; Rinitialisation des variables statiques de la fonction.
			$hGUI        = 0
			$iTexte1_Id  = 0
			$iProgre_Id  = 0
			$iTexte2_Id  = 0
			$iFaits      = 0
			$iTotal      = 0
			$bAnnulation = False
			BarreAttente_Commarea("$iAnnuler_Id", 0)

		Case "ANNULATION"
			; Appel sans tre pass d'abord par le cas "INIT".
			If Not $hGUI Then Return
			; Passage de la commande d'annulation pour la suite du cas "MAJ".
			$bAnnulation = True
	EndSwitch
EndFunc ; ==>

; ==== Usage interne ==============================================================================
; Fonction de gestion des messages Windows.
; =================================================================================================
Func BarreAttente_WM_COMMAND($hWnd, $iMsg, $wParam, $lParam)
  Local $nID = BitAND($wParam, 0x0000FFFF)

	If $nID = BarreAttente_Commarea("$iAnnuler_Id") Then
		ConsoleWrite("- BarreAttente_WM_COMMAND - " & @CRLF _
								& "$nID = " & $nID & @CRLF _
								& "----------------------------" & @CRLF)
		BarreAttente_Traitements("ANNULATION")
	EndIf

	Return 'GUI_RUNDEFMSG' ; 'GUI_RUNDEFMSG' = $GUI_RUNDEFMSG]
EndFunc ; ==> BarreAttente_WM_COMMAND

; ==== Usage interne ==============================================================================
; Sujet : - Mmorisation de variables et de leur valeurs.
;         - Accs  la valeur d'une variable.
; Param : $sVar = Nom de la variable    (Ex. : "$iVar").
;         $xVal = Valeur de la variable (Ex. : 5).
; Usage : - Appel avec 2 paramtres, stockage de variable.
;           Si elle existe dj alors elle est MAJ, sinon elle est cre.
;         - Appel avec 1 paramtre, demande de valeur de la variable .
;           Si elle existe dj alors la valeur est retourne, sinon elle est cre  vide.
; Retour: La fonction retourne toujours la valeur associe  $sVar, mme en cration.
; =================================================================================================
Func BarreAttente_Commarea($sVar = Default, $xVal = Default)
	Static Local $aVar[0][2]
	Local $i
	Switch @NumParams
		Case 2 ; --- Cration ou mise  jour -------------------------------------------
			; Si $sVar existe, MAJ de $xVal associe.
			For $i = 0 To UBound($aVar) - 1
				If $aVar[$i][0] = $sVar Then
					 $aVar[$i][1] = $xVal
					 Return $xVal
				EndIf
			Next
			; Si $sVar n'existe pas, cration et MAJ de $xVal associe.
			ReDim $aVar[UBound($aVar)+1][2]
			$aVar[UBound($aVar)-1][0] = $sVar
			$aVar[UBound($aVar)-1][1] = $xVal
			Return $xVal
		Case 1 ; --- Acquisition valeur ou cration  vide -----------------------------
			; Si $sVar existe, renvoi de $xVal associe.
			For $i = 0 To UBound($aVar) - 1
				If $aVar[$i][0] = $sVar Then Return $aVar[$i][1]
			Next
			; Si $sVar n'existe pas, cration avec $xVal associe vide et renvoi de vide.
			ReDim $aVar[UBound($aVar)+1][2]
			$aVar[UBound($aVar)-1][0] = $sVar
			Return $aVar[UBound($aVar)-1][1]
		Case 0 ; --- Rinitialisation de la table des valeurs --------------------------
			ReDim $aVar[0][2]
	EndSwitch
EndFunc ; ==> BarreAttente_Commarea

